## mingw-w64-vrpn-7.35-2.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(VRPN)

#-----------------------------------------------------------------------------
# XXX Things to make better.
#
# Repeat for all other configurable headers/libraries - see below for a list
# Move the shared-library code over to CMake's normal definition
# Improve this CPack installer.

###
# Local CMake Modules - keep this first
###
list(APPEND CMAKE_MODULE_PATH ${VRPN_SOURCE_DIR}/cmake)
include(UseBackportedModules)
include(MSVCMultipleProcessCompile)
include(CppcheckTargets)
include(SetDefaultBuildType)
include(OptionRequires)
include(CTest)
include(CheckIncludeFileCXX)

if((NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR) OR VRPN_SUBPROJECT_BUILD)
	# If you're using this as a subproject and want things installed, set VRPN_INSTALL TRUE.
	set(SUBPROJECT TRUE)
	set(DEFAULT_OFF_IF_SUBPROJECT OFF_BY_DEFAULT)
	set(TRUE_UNLESS_SUBPROJECT FALSE)
	set(QUIET_IF_SUBPROJECT QUIET) # silently search for optional deps as a subproject
	set(BUILD_TESTING FALSE) # don't build testing or create dashboard scripts if a subproject
else()
	set(VRPN_INSTALL TRUE)
	set(SUBPROJECT FALSE)
	set(DEFAULT_OFF_IF_SUBPROJECT)
	set(TRUE_UNLESS_SUBPROJECT TRUE)
	set(QUIET_IF_SUBPROJECT)
	include(CreateDashboardScripts)
endif()

###
# On Windows 7, it does not work to install in the default location,
# which is the Program Files directory, because you have to not only have
# file permission to write there but also "run as administrator."  This
# means that "make install" from a Visual Studio project fails.  To get
# around that, we need to set CMAKE_INSTALL_PREFIX to something other
# than the default.  However, it is a cache variable that has already been
# set.  If we make a local variable, it uses this rather than the cache
# variable and never tells the poor user what happened (the GUI location
# looks standard but the files end up somewhere else).  If we make it a
# non-forced cache variable, it already has a value so does not change.
# If we make it a forced cache variable, it gets overwritten every time
# and the user cannot change it on the GUI.  So we have a workaround here.
# We make a cache variable that records whether we have ever forced the
# install prefix.  If not, we force it.  If so, we don't force it again.
# This has the effect of setting it the first time cmake is run, showing
# the change in the GUI, and also letting the user change the value in
# the GUI if they don't like what we did.  If I knew how to do this only
# happen on Windows 7, I'd make the if(WIN32) more specific.
if(WIN32 AND NOT SUBPROJECT)
	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT
		AND
		(NOT
		ONCE_SET_CMAKE_INSTALL_PREFIX))
		set(ONCE_SET_CMAKE_INSTALL_PREFIX
			true
			CACHE
			INTERNAL
			"Have we set the install prefix yet?"
			FORCE)
		set(CMAKE_INSTALL_PREFIX
			C:/usr/local
			CACHE
			PATH
			"Install path prefix, prepended onto install directories"
			FORCE)
	endif()
endif()


###
# Basic packaging options and versioning

if (VRPN_INSTALL)
	include("${CMAKE_CURRENT_SOURCE_DIR}/ParseVersion.cmake")

	message(STATUS
		"Configuring the VRPN suite version ${CPACK_PACKAGE_VERSION} using the CMake-based build system\n")

	set(CPACK_PACKAGE_VENDOR
		"VRPN Community led by Sensics, Inc.")
	set(CPACK_PACKAGE_FILE_NAME
		"${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}-${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_PROCESSOR}")
	set(CPACK_SOURCE_PACKAGE_FILE_NAME
		"${PROJECT_NAME}-${CPACK_PACKAGE_VERSION}-src")
	set(CPACK_PACKAGE_CONTACT "Sensics VRPN Contact <vrpn@sensics.com>")
endif()

if (NOT SUBPROJECT)
	#-----------------------------------------------------------------------------
	# Compiler flags we got from Hans for Windows and from Sheldon Andrews
	# for other architectures.
	if(MSVC)	# MS-Windows Visual Studio, both 32 and 64 bits
		set(CMAKE_DEBUG_POSTFIX "d" CACHE STRING "add a postfix, usually d on windows")
		if(MSVC_VERSION GREATER 1310) # This compiler flag needs newer than VS.NET 2003 (7.1)
			# Choose fast, possibly less accurate floating point
			# See http://msdn.microsoft.com/en-us/library/e7s85ffb(v=vs.80).aspx
			set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /fp:fast")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /fp:fast")
		endif()

		# Do not assume fixed base address (probably for DLL integration?)
		# http://msdn.microsoft.com/en-us/library/w368ysh2(v=vs.80).aspx
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /FIXED:NO")
	else()
		# GCC compilers on 64-bit machines require -fPIC for shared libraries or libs
		# linked into shared libraries.

		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${CMAKE_SHARED_LIBRARY_C_FLAGS}")
		set(CMAKE_CXX_FLAGS
			"${CMAKE_CXX_FLAGS} ${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")
	endif()
endif()

set(SERVER_EXTRA_LIBS)
set(SERVER_LINK_FLAGS)

# Set up correct defines for Windows header compilation:
# This theoretically sets the lower-bound on operating system compatibility
# http://msdn.microsoft.com/en-us/library/windows/desktop/aa383745(v=vs.85).aspx
# NT4	0x0400
# Win2k	0x0500
# WinXP	0x0501
# WS2003SP1/WinXPSP2 	0x0502
# Vista 0x0600
# Win7  0x0601
# Win8  0x0602
# Win8.1 0x0603 (though some docs say 0x0602 with NTDDI_VERSION 0x06030000)
if(WIN32)
	set(WIN_MIN_VER 0x0500) # Default to Windows 2000
	if(MSVC AND MSVC_VERSION GREATER 1699)
		# VS2012: defaults to vista+, update 1 added XP support in additional toolset.
		if("${CMAKE_VS_PLATFORM_TOOLSET}" MATCHES "_xp")
			set(WIN_MIN_VER 0x0501) # WinXP
		else()
			set(WIN_MIN_VER 0x0600) # Vista
		endif()
	endif()
	add_definitions("-D_WIN32_WINNT=${WIN_MIN_VER}" "-DNTDDI_VERSION=${WIN_MIN_VER}0000")
endif()

#-----------------------------------------------------------------------------
# Options that control what gets built and how.

if(NOT SUBPROJECT)
	# We can build two configurations (passing defs to the compile lines) - which ones do we want?
	# Note that we can build both now, if desired!
	option(VRPN_BUILD_CLIENT_LIBRARY
		"Build the vrpn library including only client code"
		ON)
	option(VRPN_BUILD_SERVER_LIBRARY
		"Build the vrpnserver library including client and server code"
		ON)

	# Build various applications if we want them.
	option(VRPN_BUILD_CLIENTS "Build VRPN client apps and tests" ON)
	option(VRPN_BUILD_SERVERS "Build VRPN servers" ON)

	# Development tools
	if(MSVC_IDE AND MSVC_VERSION LESS 1600)
		# VS 2012 Express and newer has folder support...
		option(VRPN_BUILD_WITH_PROJECT_FOLDERS
			"Use project folders in build system - not compatible with Visual C++ Express editions!"
			OFF)
	else()
		set(VRPN_BUILD_WITH_PROJECT_FOLDERS ON)
	endif()

	set_property(GLOBAL
		PROPERTY
		USE_FOLDERS
		${VRPN_BUILD_WITH_PROJECT_FOLDERS})

	# Set a default build type
	set_default_build_type("RelWithDebInfo")

endif()

# Force use of our CMake-processed configuration header before the stock one.
include_directories("${PROJECT_BINARY_DIR}")


# Include directory needed by all of the files
include_directories(${VRPN_SOURCE_DIR}
	${VRPN_SOURCE_DIR}/atmellib
	${VRPN_SOURCE_DIR}/quat)


#-----------------------------------------------------------------------------
# Libraries we need to do our thing.
#
# CMake variables:
#   SERVER_EXTRA_LIBS - libraries to link against when building the server lib
#   EXTRA_LIBS - libraries to link against when building any VRPN lib
#
# Note that library linking is, by default, transitive:
# Specify linking here (even though static libraries might not use it
# directly - think of shared libs and your fellow developer) rather than
# in the included apps.

###
# Quatlib
###
add_subdirectory(quat)
list(APPEND EXTRA_LIBS quat)

###
# Threading (not on win32)
###
if(NOT WIN32)
	find_package(Threads REQUIRED ${QUIET_IF_SUBPROJECT})
	list(APPEND EXTRA_LIBS ${CMAKE_THREAD_LIBS_INIT})
endif()

###
# Windows-specific (non-Cygwin) dependencies
###
if(WIN32 AND NOT UNIX)
	# Winsock - needed for endianness conversion
	list(APPEND EXTRA_LIBS ws2_32)

	# Windows multimedia - needed for joywin32
	list(APPEND EXTRA_LIBS winmm)
endif()

###
# Optional packages
###
if(NOT SUBPROJECT)
	message(STATUS
		"Now searching for auto-configurable optional packages...\n")
endif()

###
# Submodules - bundled libraries/sources
###
add_subdirectory(submodules)

###
# SWIG and Python Libs (for python wrappers)
###
find_package(SWIG ${QUIET_IF_SUBPROJECT})

set(CurrentPythonSettings
	"${VRPN_BUILD_PYTHON}${VRPN_BUILD_PYTHON_HANDCODED_2X}${VRPN_BUILD_PYTHON_HANDCODED_3X}")
if(NOT CurrentPythonSettings STREQUAL _VRPN_PYTHON_SETTINGS)
	set(vrpn_python_versionsearch)
	set(vrpn_python_versionsearchargs)
	if(VRPN_BUILD_PYTHON)
		# Swig wants 2.x, I assume
		set(vrpn_python_versionsearch 2)
		set(Python_ADDITIONAL_VERSIONS "")
		if(VRPN_BUILD_PYTHON_HANDCODED_3X)
			message(FATAL_ERROR
				"Can't build both SWIG (2.x) and hand-coded 3.x Python bindings. Disable either VRPN_BUILD_PYTHON or VRPN_BUILD_PYTHON_HANDCODED_3X.")
		endif()
	elseif(VRPN_BUILD_PYTHON_HANDCODED_3X
		AND
		VRPN_BUILD_PYTHON_HANDCODED_2X)
		message(FATAL_ERROR
			"Can't build handcoded Python bindings for both 2.x and 3.x versions. Pick one, please.")
	elseif(VRPN_BUILD_PYTHON_HANDCODED_2X
		AND
		NOT
		VRPN_BUILD_PYTHON_HANDCODED_3X)
		set(vrpn_python_versionsearch 2)
		set(Python_ADDITIONAL_VERSIONS "")
	elseif(VRPN_BUILD_PYTHON_HANDCODED_3X
		AND
		NOT
		VRPN_BUILD_PYTHON_HANDCODED_2X)
		set(vrpn_python_versionsearch 3)
		set(Python_ADDITIONAL_VERSIONS 3.4)
	endif()
	unset(PYTHON_INCLUDE_DIR CACHE)
	unset(PYTHON_INCLUDE_DIR)
	unset(PYTHON_LIBRARY CACHE)
	unset(PYTHON_LIBRARY)

	set(_VRPN_PYTHON_VERSIONSEARCH
		${vrpn_python_versionsearch}
		CACHE
		INTERNAL
		""
		FORCE)
	set(_VRPN_PYTHON_SETTINGS
		${CurrentPythonSettings}
		CACHE
		INTERNAL
		""
		FORCE)
endif()

# Passing just the major version works with as desired multi-python-capable find module such
# as in latest CMake (2.8.9)
find_package(PythonLibs ${_VRPN_PYTHON_VERSIONSEARCH} ${QUIET_IF_SUBPROJECT})
if(PYTHONLIBS_FOUND)
	if(PYTHONLIBS_VERSION_STRING)
		string(SUBSTRING
			${PYTHONLIBS_VERSION_STRING}
			0
			1
			vrpn_python_majorver)
		set(PYTHON${vrpn_python_majorver}_FOUND ON)
	elseif(PYTHON_LIBRARY MATCHES "python([23])")
		set(PYTHON${CMAKE_MATCH_1}_FOUND ON)
	elseif(_VRPN_PYTHON_VERSIONSEARCH)
		set(PYTHON${_VRPN_PYTHON_VERSIONSEARCH}_FOUND ON)
	else()
		message(STATUS
			"Warning: found python but couldn't determine which version. Please set either VRPN_PYTHON_IS_3 or VRPN_PYTHON_IS_2")
		option(VRPN_PYTHON_IS_3 "Python found is version 3.x" OFF)
		option(VRPN_PYTHON_IS_2 "Python found is version 2.x" OFF)
		if(VRPN_PYTHON_IS_3 AND VRPN_PYTHON_IS_2)
			unset(VRPN_PYTHON_IS_2 CACHE)
			unset(VRPN_PYTHON_IS_3 CACHE)
			message(FATAL_ERROR
				"If needed, please set either VRPN_PYTHON_IS_3 or VRPN_PYTHON_IS_2, not both!")
		elseif(VRPN_PYTHON_IS_3)
			set(PYTHON3_FOUND ON)
		elseif(VRPN_PYTHON_IS_2)
			set(PYTHON2_FOUND ON)
		endif()
	endif()
endif()

# If MSVC, and we don't have a debug lib, default to off, or the default (debug runtime) build is broken.
if(MSVC AND NOT PYTHON_LIBRARY_DEBUG)
	set(PYTHON_DEFAULT_OFF OFF_BY_DEFAULT)
else()
	set(PYTHON_DEFAULT_OFF ${DEFAULT_OFF_IF_SUBPROJECT})
endif()
option_requires(VRPN_BUILD_PYTHON
	"Build VRPN Python 2.x SWIG-based bindings"
	${PYTHON_DEFAULT_OFF}
	SWIG_FOUND
	PYTHON2_FOUND)

option_requires(VRPN_BUILD_PYTHON_HANDCODED_2X
	"Build VRPN Python handcoded bindings for Python 2.x"
	${PYTHON_DEFAULT_OFF}
	PYTHON2_FOUND)

option_requires(VRPN_BUILD_PYTHON_HANDCODED_3X
	"Build VRPN Python handcoded bindings for Python 3.x"
	${PYTHON_DEFAULT_OFF}
	PYTHON3_FOUND)

###
# javac, jar, and javah (for java wrapper)
###
if(ANDROID AND DEFINED find_host_package)
	find_host_package(Java COMPONENTS Development)
	find_host_package(JNI)
	find_host_program(JAVAH_EXECUTABLE NAMES javah)
else()
	find_package(Java COMPONENTS Development ${QUIET_IF_SUBPROJECT})
	find_package(JNI ${QUIET_IF_SUBPROJECT})
	find_program(JAVAH_EXECUTABLE NAMES javah)
endif()
mark_as_advanced(JAVAH_EXECUTABLE)

=== Makefile ===
#############################################################################
#	Makefile for VRPN libraries.  Needs to be built using 'gmake'.
# Should run on any architecture that is currently supported.  It should
# be possible to build simultaneously on multiple architectures.
#
# On the sgi, both g++ and CC versions are built by default.
#
# Author: Russ Taylor, 10/2/1997
#
# modified:
# * Andrew Roth June 16/2012
#	 * Updates for MacOSX builds for 32/64, 64 bit and Xcode 4.3
# * Jeff Juliano, 10/99
#    * added "make depend"  (see comments at end of this makefile)
#    * changed to use RM, RMF, MV, and MVF
#      these are overridable as follows:
#          gmake RM=/mybin/rm,  or  gmake RMF="/bin/rm -option"
# * Jeff Juliano, 9/1999
#     support for parallel make (see WARNING below)
# * Tom Hudson, 25 Jun 1998
#     Support for n32 ABI on sgi.  (gmake n32)
# * Hans Weber, ???
#     Support for both g++ and native compilers on sgi.
# * Tom Hudson, 13 Feb 1998
#     Build two different libraries:  client (libvrpn) and server
#     (libvrpnserver).  Our solution is to compile twice, once with the
#     flag -DVRPN_CLIENT_ONLY and once without.  Any server-specific code
#     (vrpn_3Space, vrpn_Tracker_Fastrak, vrpn_Flock) should ONLY be
#     compiled into the server library!
#############################################################################

##########################
# common definitions. For non-UNC sites, uncomment one of the lines
# that defines hw_os for the machine you are on in the section just
# below. Then, the code should compile in your environment.
#
#HW_OS := sgi_irix
#HW_OS := pc_linux
#HW_OS := pc_linux64
#HW_OS := pc_linux_ia64
# Try this to cross-compile on a Linux PC for an ARM embedded controller.
#HW_OS := pc_linux_arm
# Try this to cross-compile on a Cygwin PC for an ARM embedded controller.
#HW_OS := pc_cygwin_arm
#HW_OS := pc_cygwin
#HW_OS := pc_FreeBSD
#HW_OS := sparc_solaris
#HW_OS := sparc_solaris_64
#HW_OS := powerpc_aix
#HW_OS := powerpc_macosx
#HW_OS := universal_macosx
#HW_OS := macosx_32_64
#HW_OS := macosx_64
##########################

##########################
# Mac OS X-specific options. If HW_OS is powerpc_macosx or universal_macosx,
# uncomment one line below to choose the minimum targeted OS X version and
# corresponding SDK. If none of the lines below is commented out, 10.5 will
# be the minimum version.  10.7/4.3 removes ppc support.  In Xcode 4.3 - you 
# must now manually install command line tools from: 
# Xcode menu > Preferences > Downloads.
##########################
#MAC_OS_MIN_VERSION := 10.4
#MAC_OS_MIN_VERSION := 10.5
#MAC_OS_MIN_VERSION := 10.6
#MAC_OS_MIN_VERSION := 10.7
#MAC_OS_MIN_VERSION := 10.8

INSTALL_DIR := /usr/local
BIN_DIR := $(INSTALL_DIR)/bin
INCLUDE_DIR := $(INSTALL_DIR)/include
LIB_DIR := $(INSTALL_DIR)/lib

MV = /bin/mv
MVF = $(MV) -f

RM = /bin/rm
RMF = $(RM) -f

ifndef HW_OS
  # hw_os does not exist on FreeBSD at UNC or on CYGWIN
  UNAME := $(shell uname -s)
  ifeq ($(UNAME), FreeBSD)
    HW_OS := pc_FreeBSD
  else
    # pc_cygwin doesn't have HW_OS
    ifeq ($(UNAME), CYGWIN_NT-4.0)
      HW_OS := pc_cygwin
      # On cygwin make is gmake (and gmake doesn't exist)
      MAKE  := make -f $(MAKEFILE)
    else
      ifeq ($(UNAME), CYGWIN_98-4.10)
	    HW_OS := pc_cygwin
	    MAKE := make -f $(MAKEFILE)
      else
        ifeq ($(UNAME), CYGWIN_NT-5.0)
	    HW_OS := pc_cygwin
	    MAKE := make -f $(MAKEFILE)
        else
	    HW_OS := $(shell hw_os)
        endif
      endif
    endif
  endif
endif

# check if its for pxfl
ifdef PBASE_ROOT
  HW_OS := hp_flow
  ifeq ($(PXFL_COMPILER), aCC)
    HW_OS = hp_flow_aCC
  endif
endif

ifeq (,$(strip $(HW_OS)))
$(error You must define HW_OS when calling make. See the makefile for example values)
all:
	@echo "ERROR: You must define HW_OS when calling make. See the makefile for example values." 1>&2
endif

# Which C++ compiler to use.  Default is g++, but some don't use this.
#
# IF YOU CHANGE THESE, document either here or in the header comment
# why.  Multiple contradictory changes have been made recently.

# These should be defaulting to useful values on the platform.
# If they aren't, use gcc.

# C compiler
CC ?= gcc

# C++ compiler
CXX ?= g++

# These probably aren't defaulting to anything useful.
AR := ar ruv
# need default 'ranlib' to be touch for platforms that don't use it,
# otherwise make fails.
RANLIB ?= touch

ifeq ($(FORCE_GPP),1)
  CC := g++
else

  ifeq ($(HW_OS),sparc_solaris)
    CC := /opt/SUNWspro/bin/CC
    AR := /opt/SUNWspro/bin/CC -xar -o
  endif

  ifeq ($(HW_OS),sparc_solaris_64)
    CC := /opt/SUNWspro/bin/CC -xarch=v9a
    AR := /opt/SUNWspro/bin/CC -xarch=v9a -xar -o
  endif

  ifeq ($(HW_OS),powerpc_aix)
    CC := /usr/ibmcxx/bin/xlC_r -g -qarch=pwr3 -w
    RANLIB := ranlib
  endif

  ifeq ($(HW_OS),pc_linux64)
    STANDARD_CFLAGS := -m64 -fPIC
    RANLIB := ranlib
  endif

  ifeq ($(HW_OS),pc_linux)
    STANDARD_CFLAGS := -fPIC
    RANLIB := ranlib
  endif

  ifeq ($(HW_OS), pc_linux_ia64)
    RANLIB := ranlib
  endif

  ifneq (,$(findstring macosx,$(HW_OS)))
    ifndef MAC_OS_MIN_VERSION
      MAC_OS_MIN_VERSION := 10.5
    endif

    # Select which compiler and MAC OS X SDK to use
    MAC_CC := gcc
    MAC_CXX := g++
    ifeq ($(MAC_OS_MIN_VERSION), 10.8)
      MAC_OS_SDK := MacOSX10.8.sdk
    else
      ifeq ($(MAC_OS_MIN_VERSION), 10.7)
        MAC_OS_SDK := MacOSX10.7.sdk
      else
        ifeq ($(MAC_OS_MIN_VERSION), 10.6)
          MAC_OS_SDK := MacOSX10.6.sdk
        else
          ifeq ($(MAC_OS_MIN_VERSION), 10.5)
            MAC_OS_SDK := MacOSX10.5.sdk
          else
            MAC_OS_SDK := MacOSX10.4u.sdk
            MAC_CC := gcc-4.0
            MAC_CXX := g++-4.0
          endif
        endif
       endif
      endif
    endif
 
ifneq (,$(findstring macosx,$(HW_OS)))
  ifeq ($(wildcard /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/$(MAC_OS_SDK)),/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/$(MAC_OS_SDK))
    PATH_TO_DEV := /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/$(MAC_OS_SDK)
    $(info ---> Xcode 4.3+: Platform SDK found.  Setting dev path to $(PATH_TO_DEV)) 
  else
    PATH_TO_DEV := /Developer/SDKs/$(MAC_OS_SDK)
    $(info Xcode 4.3+: Platform SDK not found in /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/$(MAC_OS_SDK)!  Attempting to locate SDK in $(PATH_TO_DEV))
  endif
  CC := $(MAC_CC)
  CXX := $(MAC_CXX)
  STANDARD_CFLAGS := -isysroot /Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
  SYSLIBS := -framework CoreFoundation -framework IOKit -framework System
endif

  ifeq ($(HW_OS),powerpc_macosx)
    STANDARD_CFLAGS := -arch ppc $(STANDARD_CFLAGS)
    RANLIB := ranlib
    AR := libtool -static -o
  endif

  ifeq ($(HW_OS),universal_macosx)
    STANDARD_CFLAGS := -arch ppc -arch i386 -arch x86_64 $(STANDARD_CFLAGS)
    RANLIB := :
    AR := libtool -static -o
  endif
  
  ifeq ($(HW_OS),macosx_32_64)
    STANDARD_CFLAGS := -arch i386 -arch x86_64 $(STANDARD_CFLAGS)
    RANLIB := :
    AR := libtool -static -o
  endif
  
  ifeq ($(HW_OS),macosx_64)
    STANDARD_CFLAGS := -arch x86_64 $(STANDARD_CFLAGS)
    RANLIB := :
    AR := libtool -static -o
  endif
       
  ifeq ($(HW_OS),pc_linux_arm)
    CC := arm-linux-gcc
    CXX := arm-linux-g++
    RANLIB := arm-linux-ranlib
    AR := arm-linux-ar ruv
  endif

  ifeq ($(HW_OS),pc_cygwin_arm)
    CC := arm-unknown-linux-gnu-gcc
    CXX := arm-unknown-linux-gnu-g++
    RANLIB := arm-unknown-linux-gnu-ranlib
    AR := arm-unknown-linux-gnu-ar ruv
  endif

  ifeq ($(HW_OS),sgi_irix)
   ifndef SGI_ABI
      SGI_ABI := n32
   endif
   ifndef SGI_ARCH
      SGI_ARCH := mips3
   endif
   OBJECT_DIR_SUFFIX := .$(SGI_ABI).$(SGI_ARCH)
   CC := CC -$(SGI_ABI) -$(SGI_ARCH) -LANG:std
   RANLIB := :
  endif

  ifeq ($(HW_OS),hp700_hpux10)
	CC := CC +a1
  endif
  ifeq ($(HW_OS),pc_cygwin)
	CC := g++
  endif
  ifeq ($(HW_OS),sparc_sunos)
	CC := /usr/local/lib/CenterLine/bin/CC
  endif
  ifeq ($(HW_OS), hp_flow_aCC)
	CC := /opt/aCC/bin/aCC
  endif
endif

#ifeq ($(HW_OS),sparc_solaris)
#  AR := /usr/ccs/bin/ar
#endif

##########################
# directories
#

# subdirectory for make
ifeq ($(FORCE_GPP),1)
OBJECT_DIR	 := $(HW_OS)$(OBJECT_DIR_SUFFIX)/g++
SOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/g++/server
AOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/atmellib
GOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/gpsnmealib
else
UNQUAL_OBJECT_DIR := $(HW_OS)$(OBJECT_DIR_SUFFIX)
UNQUAL_SOBJECT_DIR := $(HW_OS)$(OBJECT_DIR_SUFFIX)/server
UNQUAL_AOBJECT_DIR := $(HW_OS)$(OBJECT_DIR_SUFFIX)/atmellib
UNQUAL_GOBJECT_DIR := $(HW_OS)$(OBJECT_DIR_SUFFIX)/gpsnmealib
OBJECT_DIR	 := $(HW_OS)$(OBJECT_DIR_SUFFIX)
SOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/server
AOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/atmellib
GOBJECT_DIR      := $(HW_OS)$(OBJECT_DIR_SUFFIX)/gpsnmealib
endif

# directories that we can do an rm -f on because they only contain
# object files and executables
SAFE_KNOWN_ARCHITECTURES :=	\
	hp700_hpux/* \
	hp700_hpux10/* \
	mips_ultrix/* \
	pc_linux/* \
	sgi_irix.32/* \
	sgi_irix.n32/* \
	sparc_solaris/* \
	sparc_solaris_64/* \
	sparc_sunos/* \
	pc_cygwin/* \
	powerpc_aix/* \
	pc_linux_arm/* \
	powerpc_macosx/* \
	universal_macosx/* \
	macosx_32_64/* \
	macosx_64/* \
	pc_linux64/* \
	pc_linux_ia64/*

CLIENT_SKA = $(patsubst %,client_src/%,$(SAFE_KNOWN_ARCHITECTURES))
SERVER_SKA = $(patsubst %,server_src/%,$(SAFE_KNOWN_ARCHITECTURES))

##########################
# Include flags
#

#SYS_INCLUDE := -I/usr/local/contrib/include -I/usr/local/contrib/mod/include
SYS_INCLUDE :=

ifeq ($(HW_OS),powerpc_macosx)
#   SYS_INCLUDE := -I/usr/include
    SYS_INCLUDE :=-DMACOSX -I../isense
endif

ifeq ($(HW_OS),universal_macosx)
#   SYS_INCLUDE := -I/usr/include
    SYS_INCLUDE :=-DMACOSX -I../isense
endif

ifeq ($(HW_OS),macosx_32_64)
#   SYS_INCLUDE := -I/usr/include
    SYS_INCLUDE :=-DMACOSX -I../isense
endif

ifeq ($(HW_OS),macosx_64)
#   SYS_INCLUDE := -I/usr/include
    SYS_INCLUDE :=-DMACOSX -I../isense
endif

ifeq ($(HW_OS),pc_linux)
    # The following is for the InterSense and Freespace libraries.
    SYS_INCLUDE := -DUNIX -DLINUX -I../libfreespace/include -I./submodules/hidapi/hidapi -I/usr/include/libusb-1.0
	# On linux, build this as c, not c++.
    $(HW_OS)/server/vrpn_Local_HIDAPI.o: EXTRA_FLAGS += -x c
endif

ifeq ($(HW_OS),pc_linux64)
    # The following is for the InterSense and Freespace libraries.
    SYS_INCLUDE := -DUNIX -DLINUX -I../libfreespace/include -I./submodules/hidapi/hidapi -I/usr/include/libusb-1.0
	# On linux, build this as c, not c++.
    $(HW_OS)/server/vrpn_Local_HIDAPI.o: EXTRA_FLAGS += -x c
endif

ifeq ($(HW_OS),pc_linux_arm)
    SYS_INCLUDE := -I/opt/Embedix/arm-linux/include
#   -I/usr/local/contrib/include \
#	  	 -I/usr/local/contrib/mod/include -I/usr/include/bsd \
#		 -I/usr/include/g++
endif

ifeq ($(HW_OS),pc_cygwin_arm)
   SYS_INCLUDE := -I/opt/Embedix/arm-linux/include
#   -I/usr/local/contrib/include \
#	  	 -I/usr/local/contrib/mod/include -I/usr/include/bsd \
#		 -I/usr/include/g++
endif

ifeq ($(HW_OS),sgi_irix)
#  SYS_INCLUDE := -I/usr/local/contrib/mod/include
  SYS_INCLUDE :=
endif

ifeq ($(HW_OS),hp700_hpux10)
  SYS_INCLUDE := -I/usr/local/contrib/include -I/usr/local/contrib/mod/include \
                 -I/usr/include/bsd
endif

ifeq ($(HW_OS),hp_flow)
  SYS_INCLUDE := -I/usr/local/contrib/include -I/usr/local/contrib/mod/include \
                 -I/usr/include/bsd -DFLOW
endif

ifeq ($(HW_OS),hp_flow_aCC)
  SYS_INCLUDE := -I/usr/local/contrib/include -I/usr/local/contrib/mod/include \
                 -I/usr/include/bsd -DFLOW
endif

# On the PC, place quatlib in the directory ./quat.  No actual system
# includes should be needed.
ifeq ($(HW_OS),pc_cygwin)

=== client_src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#-----------------------------------------------------------------------------
# XXX Things to make better.
#
# XXX clock_drift_estimator
# Move applications into subprojects in visual studio
# Make the files with ".c" extension also compile as C++.
# Make the c_interface_example work

#-----------------------------------------------------------------------------
# Build the client applications if we've been asked to.
if(VRPN_BUILD_CLIENTS)

	if(NOT VRPN_CLIENT_LIBRARY)
		message(FATAL_ERROR
			"Cannot compile clients without either the client or full library.  Enable one and try again.")
	endif()

	#-----------------------------------------------------------------------------
	# Libraries we need to do our thing.
	find_package(GLUT)
	if(APPLE)
		mark_as_advanced(GLUT_cocoa_LIBRARY)
	endif()
	find_package(OpenGL)

	set(CLIENTS_SOURCES
	vrpn_average_analogs.C
		vrpn_print_devices.C
		vrpn_log_devices.C
		vrpn_print_performance.C
		vrpn_print_messages.C
	)

	set(TEST_SOURCES
		add_vrpn_cookie.C
		bdbox_client.C
		clock_drift_estimator.C
		ff_client.C
		forcedevice_test_client.cpp
		forwarderClient.C
		#midi_client.C # XXX TODO No vrpn_Sound_Remote ever defined in this repository
		#ohm_client.C # XXX TODO No vrpn_Ohmmeter (vrpn_Ohmmeter.h) defined in this repository
		phan_client.C
		printcereal.C
		printvals.C
		sound_client.C
		sphere_client.C
		testSharedObject.C
		test_Zaber.C
		test_imager.C
		test_mutex.C
		text.C
		tracker_to_poser.cpp
		vrpn_LamportClock.t.C
		vrpn_ping.C
	)

	if(NOT WIN32)
		# TODO: These need "open" calls modified to build on win.
		list(APPEND
			TEST_SOURCES
			logfilesenders.C
			logfiletypes.C
			checklogfile.C)
	endif()

	###
	# Tests
	###
	if(BUILD_TESTING)
		foreach(SOURCE ${TEST_SOURCES})
			get_filename_component(APP ${SOURCE} NAME_WE)
			add_executable(${APP} ${SOURCE})
			target_link_libraries(${APP} ${VRPN_CLIENT_LIBRARY})

			set_target_properties(${APP} PROPERTIES FOLDER Tests)
			if(VRPN_INSTALL)
				install(TARGETS ${APP} RUNTIME DESTINATION bin COMPONENT tests)
			endif()
		endforeach()

    add_test(test_imager test_imager)

		if(GLUT_FOUND AND OPENGL_FOUND)

			option(VRPN_GLUT_IS_STATIC_FREEGLUT
				"Is the GLUT used a static build of FreeGLUT?"
				NO)
			mark_as_advanced(VRPN_GLUT_IS_STATIC_FREEGLUT)

			include_directories(${GLUT_INCLUDE_DIR} ${OPENGL_INCLUDE_DIR})
			add_executable(testimager_client testimager_client.C)
			target_link_libraries(testimager_client
				${VRPN_CLIENT_LIBRARY}
				${GLUT_LIBRARIES}
				${OPENGL_LIBRARIES})
			set_target_properties(testimager_client PROPERTIES FOLDER Tests)

			if(VRPN_INSTALL)
				install(TARGETS
					testimager_client
					RUNTIME
					DESTINATION
					bin
					COMPONENT
					tests)
			endif()

			if(VRPN_GLUT_IS_STATIC_FREEGLUT)
				set_property(TARGET
					testimager_client
					PROPERTY
					COMPILE_DEFINITIONS
					"FREEGLUT_STATIC")
			endif()

			include_directories(${GLUT_INCLUDE_DIR} ${OPENGL_INCLUDE_DIR})
			add_executable(vrpn_orientation vrpn_orientation.C)
			target_link_libraries(vrpn_orientation
				${VRPN_CLIENT_LIBRARY}
				${GLUT_LIBRARIES}
				${OPENGL_LIBRARIES})
			set_target_properties(vrpn_orientation PROPERTIES FOLDER Clients)

			if(VRPN_INSTALL)
				install(TARGETS
					vrpn_orientation
					RUNTIME
					DESTINATION
					bin
					COMPONENT
					clients)
			endif()

			if(VRPN_GLUT_IS_STATIC_FREEGLUT)
				set_property(TARGET
					vrpn_orientation
					PROPERTY
					COMPILE_DEFINITIONS
					"FREEGLUT_STATIC")
			endif()

		endif()

	endif()

	add_executable(c_interface_example
		c_interface_example.c
		c_interface.h
		c_interface.cpp)
	target_link_libraries(c_interface_example ${VRPN_CLIENT_LIBRARY})

	set_target_properties(c_interface_example PROPERTIES FOLDER Tests)

	if(VRPN_INSTALL)
		install(TARGETS
			c_interface_example
			RUNTIME
			DESTINATION
			bin
			COMPONENT
			tests)
	endif()


	###
	# Clients
	###
	foreach(SOURCE ${CLIENTS_SOURCES})
		get_filename_component(APP ${SOURCE} NAME_WE)
		add_executable(${APP} ${SOURCE})
		target_link_libraries(${APP} ${VRPN_CLIENT_LIBRARY})

		set_target_properties(${APP} PROPERTIES FOLDER Clients)

		if(VRPN_INSTALL)
			install(TARGETS ${APP} RUNTIME DESTINATION bin COMPONENT clients)
		endif()
	endforeach()

	###
	# Servers
	###
	add_executable(run_auxiliary_logger run_auxiliary_logger.C)
	target_link_libraries(run_auxiliary_logger ${VRPN_CLIENT_LIBRARY})
	set_target_properties(run_auxiliary_logger PROPERTIES FOLDER Servers)
	if(VRPN_INSTALL)
		install(TARGETS
			run_auxiliary_logger
			RUNTIME
			DESTINATION
			bin
			COMPONENT
			servers)
	endif()

endif()

=== doxygen/CMakeLists.txt ===
# Changes made by:
# 2009-2010 Ryan Pavlik <rpavlik@iastate.edu>
# http://academic.cleardefinition.com
# Iowa State University HCI Graduate Program/VRAC

include(DoxygenTargets)

#-----------------------------------------------------------------------------
# Create documentation
add_doxygen(Doxyfile
	INSTALL_DESTINATION
	share/doc/vrpn-${BRIEF_VERSION}/source-docs
	NO_PDF
	INSTALL_COMPONENT
	doc)	# For some reason, LaTeX bails with a nesting-too-deep error

=== hid_gui/CMakeLists.txt ===

if(NOT VRPN_BUILD_SERVER_LIBRARY OR NOT VRPN_USE_HID)
	message(FATAL_ERROR
		"Cannot compile HID gui without the full (server) library and HID support.  Enable it and try again.")
endif()

set(VRPN_SERVER_LIBRARY vrpnserver)

if(NOT WIN32)
	set(VRPN_ATMEL_LIBRARY vrpn_atmel)
endif()

set(SOURCES
	HIDDevice.cpp
	Inspector.cpp
	main.cpp
	MainWindow.cpp
	QuickChart.cpp)

set(HEADERS)

set(MOCS
	HIDDevice.h
	Inspector.h
	MainWindow.h
	QuickChart.h)

set(UIS
	mainwindow.ui
	plot.ui)

find_package(Qt5 COMPONENTS Gui Widgets)
if(NOT TARGET Qt5::Core)
	message("No Qt5")
	find_package(Qt4 4.7)
endif()

if(TARGET Qt5::Core)
	qt5_wrap_ui(GENERATED_SOURCES ${UIS})
	qt5_wrap_cpp(GENERATED_SOURCES ${MOCS})
elseif(QT_FOUND)
	include(${QT_USE_FILE})
	qt4_wrap_ui(GENERATED_SOURCES ${UIS})
	qt4_wrap_cpp(GENERATED_SOURCES ${MOCS})
endif()

if(TARGET Qt5::Core OR QT_FOUND)
	source_group("Generated Sources - Do Not Edit"
		FILES
		${GENERATED_SOURCES})
	include_directories(${CMAKE_CURRENT_BINARY_DIR})

	# Build and link the app!
	add_executable(vrpn_hid_gui
		MACOSX_BUNDLE
		${SOURCES}
		${GENERATED_SOURCES}
		${HEADERS}
		${UIS}
		${MOCS}
		${RESOURCES})
	target_link_libraries(vrpn_hid_gui ${QT_LIBRARIES} vrpnserver)
endif()
if(TARGET Qt5::Core)
	qt5_wrap_ui(GENERATED_SOURCES ${UIS})
	qt5_wrap_cpp(GENERATED_SOURCES ${MOCS})
	qt5_use_modules(vrpn_hid_gui Widgets)
elseif(QT_FOUND)
	target_link_libraries(vrpn_hid_gui ${QT_LIBRARIES})
endif()

=== java_vrpn/CMakeLists.txt ===
# 2009-2010 Ryan Pavlik <rpavlik@iastate.edu>
# http://academic.cleardefinition.com
# Iowa State University HCI Graduate Program/VRAC

# XXX TODO Install these bindings, don't just build them!

if(JAVA_FOUND AND JNI_FOUND AND JAVAH_EXECUTABLE AND VRPN_BUILD_JAVA AND NOT ${Java_VERSION_MAJOR} LESS 8)

	# Set up file lists
	set(JAVA_CLASSES
		AnalogOutputRemote
		AnalogRemote
		AnalogRemoteListener
		AuxiliaryLoggerRemote
		ButtonRemote
		ButtonRemoteListener
		ForceDeviceRemote
		ForceDeviceRemoteListener
		FunctionGeneratorRemote
		PoserRemote
		TextReceiver
		TextSender
		TrackerRemote
		TrackerRemoteListener
		VRPN
		VRPNDevice)
	set(JAVAC_OUTPUT)
	set(JAVAC_INPUT)
	set(JAVA_JNI_HEADERS)
	foreach(class ${JAVA_CLASSES})
		set(SRC "${CMAKE_CURRENT_SOURCE_DIR}/vrpn/${class}.java")
		set(HEADER "${CMAKE_CURRENT_BINARY_DIR}/vrpn_${class}.h")
		set(CLASS "${CMAKE_CURRENT_BINARY_DIR}/vrpn/${class}.class")
		list(APPEND
			JAVAC_OUTPUT "${CLASS}"
			)
		list(APPEND
			JAVAC_INPUT "${SRC}")
		list(APPEND
			JAVA_JNI_HEADERS
			"${HEADER}/")
	endforeach()

	# *.java -> *.class and *.h in one step (since javah doesn't work so great anymore?)
	add_custom_command(OUTPUT
		${JAVAC_OUTPUT}
		DEPENDS
		${JAVAC_INPUT}
		COMMAND
		"${Java_JAVAC_EXECUTABLE}"
		-d
		"${CMAKE_CURRENT_BINARY_DIR}"
		${JAVAC_INPUT}
		# This part puts the native header where we want
		-h
		"${CMAKE_CURRENT_BINARY_DIR}"
		COMMENT
		"Compiling Java sources to class files...")

	# *.class -> vrpn.jar
	add_custom_command(OUTPUT
		"${CMAKE_CURRENT_BINARY_DIR}/vrpn.jar"
		DEPENDS
		${JAVAC_OUTPUT}
		COMMAND
		${CMAKE_COMMAND}
		ARGS
		-E
		chdir
		"${CMAKE_CURRENT_BINARY_DIR}"
		${Java_JAR_EXECUTABLE}
		-cvf
		"${CMAKE_CURRENT_BINARY_DIR}/vrpn.jar"
		"${CMAKE_CURRENT_BINARY_DIR}/vrpn"
		COMMENT
		"Generating JAR file...")

	# *.class -> vrpn_*.h
	foreach(in ${JAVA_CLASSES})
		add_custom_command(OUTPUT
			"${CMAKE_CURRENT_BINARY_DIR}/vrpn_${in}.h"
			DEPENDS
			"${CMAKE_CURRENT_BINARY_DIR}/vrpn/${in}.class"
			COMMAND
			"${JAVAH_EXECUTABLE}"
			-d
			"${CMAKE_CURRENT_BINARY_DIR}"
			-jni
			-classpath
			"${CMAKE_CURRENT_BINARY_DIR}"
			vrpn.${in}
			COMMENT
			"Generating JNI header file for vrpn.${in}")
	endforeach()

	# target for vrpn.jar
	add_custom_target(java_vrpn_jar
		DEPENDS
		"${CMAKE_CURRENT_BINARY_DIR}/vrpn.jar")

	# java_vrpn library
	set(LIB_SOURCES
		java_vrpn.cpp
		vrpn_AnalogOutputRemote.cpp
		vrpn_AnalogRemote.cpp
		vrpn_AuxiliaryLoggerRemote.cpp
		vrpn_ButtonRemote.cpp
		vrpn_ForceDeviceRemote.cpp
		vrpn_PoserRemote.cpp
		vrpn_TextReceiver.cpp
		vrpn_TextSender.cpp
		vrpn_TrackerRemote.cpp
		vrpn_VRPNDevice.cpp
		vrpn_FunctionGeneratorRemote.cpp)

	include_directories("${CMAKE_CURRENT_BINARY_DIR}" ${JNI_INCLUDE_DIRS})
	add_library(java_vrpn SHARED ${LIB_SOURCES} ${JAVA_JNI_HEADERS})
	if(BUILD_WITH_ANDROID_NDK)
		# Currently link with the client-side libraries only for the Android build.
		target_link_libraries(java_vrpn vrpn)
	else()
		target_link_libraries(java_vrpn vrpnserver ${JAVA_JVM_LIBRARY})
		add_dependencies(java_vrpn java_vrpn_jar)
	endif()

	if(VRPN_INSTALL)
		install(TARGETS java_vrpn
			ARCHIVE DESTINATION lib COMPONENT java
			LIBRARY DESTINATION lib COMPONENT java
			RUNTIME DESTINATION lib COMPONENT java)

		install(FILES "${CMAKE_CURRENT_BINARY_DIR}/vrpn.jar"
			DESTINATION share/java
			COMPONENT java
			RENAME vrpn-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.jar)
	endif()
endif()

=== python/CMakeLists.txt ===

if(PYTHONLIBS_FOUND AND (VRPN_BUILD_PYTHON_HANDCODED_2X OR VRPN_BUILD_PYTHON_HANDCODED_3X))
	include_directories(${PYTHON_INCLUDE_DIRS} "${CMAKE_CURRENT_SOURCE_DIR}")

	set(PYTHONVERSIONDIR python)
	if(PYTHON_LIBRARY MATCHES "python([23].[0-9])")
		set(PYTHONVERSIONDIR "python${CMAKE_MATCH_1}/")
	endif()

	if(WIN32)
		add_definitions(-DCALLBACK_CALL=__stdcall)
	else()
		add_definitions(-DCALLBACK_CALL=)
	endif()
	python_add_module(vrpn-python
		Base.cpp
		Connection.cpp
		Device.cpp
		callback.cpp
		include/Base.hpp
		include/Connection.hpp
		include/Device.hpp
		include/callback.hpp
		include/definition.hpp
		include/exceptions.hpp
		include/handlers.hpp
		include/interface.hpp
		include/tools.hpp
		interface.cpp
		quaternion/quaternion.cpp
		receiver/Analog.cpp
		receiver/Button.cpp
		receiver/Dial.cpp
		receiver/Text_Receiver.cpp
		receiver/Tracker.cpp
		receiver/include/Analog.hpp
		receiver/include/Button.hpp
		receiver/include/Dial.hpp
		receiver/include/Text_Receiver.hpp
		receiver/include/Tracker.hpp
		receiver/receiver.cpp
		sender/Poser.cpp
		sender/Text_Sender.cpp
		sender/include/Poser.hpp
		sender/include/Text_Sender.hpp
		sender/sender.cpp
		tools.cpp)
	target_link_libraries(vrpn-python ${PYTHON_LIBRARIES} vrpnserver)
	set_target_properties(vrpn-python
		PROPERTIES
		FOLDER "Python Bindings"
		OUTPUT_NAME vrpn)

	if(VRPN_INSTALL)
		if(WIN32)
#			install(TARGETS vrpn-python
#				RUNTIME DESTINATION lib/${PYTHONVERSIONDIR}dist-packages/ COMPONENT python
#				LIBRARY DESTINATION lib/${PYTHONVERSIONDIR}dist-packages/ COMPONENT python)
		else()
			install(TARGETS vrpn-python
				RUNTIME DESTINATION lib/${PYTHONVERSIONDIR}dist-packages/ COMPONENT python
				LIBRARY DESTINATION lib/${PYTHONVERSIONDIR}dist-packages/ COMPONENT python)
		endif()
	endif()
endif()

=== quat/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(quatlib)

if(APPLE)
	# XXX Is this still needed?
	if(NOT CMAKE_INSTALL_NAME_DIR)
		set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
	endif()
endif()

set(QUATLIB_SOURCES matrix.c quat.c vector.c xyzquat.c)
set(QUATLIB_HEADER quat.h)

# Build the library itself and declare what bits need to be installed
add_library(quat ${QUATLIB_SOURCES} ${QUATLIB_HEADER})
if(UNIX)
	target_link_libraries(quat -lm)
endif()
set_property(TARGET quat PROPERTY PUBLIC_HEADER ${QUATLIB_HEADER})
set_target_properties(quat PROPERTIES FOLDER Library)
if(VRPN_INSTALL)
	install(TARGETS
		quat
		RUNTIME DESTINATION bin COMPONENT serversdk
		LIBRARY DESTINATION lib${LIB_SUFFIX} COMPONENT serversdk
		ARCHIVE DESTINATION lib${LIB_SUFFIX} COMPONENT serversdk
		PUBLIC_HEADER DESTINATION include COMPONENT serversdk)
	install(TARGETS
		quat
		RUNTIME DESTINATION bin COMPONENT clientsdk
		LIBRARY DESTINATION lib${LIB_SUFFIX} COMPONENT clientsdk
		ARCHIVE DESTINATION lib${LIB_SUFFIX} COMPONENT clientsdk
		PUBLIC_HEADER DESTINATION include COMPONENT clientsdk)
endif()

add_subdirectory(testapps)

=== quat/Makefile ===
#############################################################################
#
# makefile for quaternion lib
#
#############################################################################

##########################
# common definitions. For non-UNC sites, uncomment one of the lines
# that defines hw_os for the machine you are on in the section just
# below. Then, the code should compile in your environment.
#
#HW_OS := sgi_irix
#HW_OS := pc_linux
#HW_OS := pc_linux64
#HW_OS := pc_linux_ia64
# Set this to compile for ARM gcc compiler to use on embedded devices
# from a Linux box.
#HW_OS := pc_linux_arm
# Try this to compile for ARM gcc compiler to use on embedded devices
# from a Cygwin environment.
#HW_OS := pc_cygwin_arm
#HW_OS := pc_cygwin
#HW_OS := pc_FreeBSD
#HW_OS := sparc_solaris
#HW_OS := sparc_solaris_64
#HW_OS := powerpc_aix
#HW_OS := powerpc_macosx
#HW_OS := universal_macosx
#HW_OS := macosx_32_64
#HW_OS := macosx_64
##########################

##########################
# Mac OS X-specific options. If HW_OS is powerpc_macosx or universal_macosx,
# uncomment one line below to choose the minimum targeted OS X version and
# corresponding SDK. If none of the lines below is commented out, 10.5 will
# be the minimum version.
##########################
#MAC_OS_MIN_VERSION := 10.4
#MAC_OS_MIN_VERSION := 10.5
#MAC_OS_MIN_VERSION := 10.6
#MAC_OS_MIN_VERSION := 10.7
#MAC_OS_MIN_VERSION := 10.8


INSTALL_DIR := /usr/local
BIN_DIR := $(INSTALL_DIR)/bin
INCLUDE_INSTALL_DIR := $(INSTALL_DIR)/include
LIB_INSTALL_DIR := $(INSTALL_DIR)/lib

ifndef HW_OS
  # hw_os does not exist on FreeBSD at UNC or on CYGWIN
  UNAME := $(shell uname -s)
  ifeq ($(UNAME), FreeBSD)
    HW_OS := pc_FreeBSD
  else
    # pc_cygwin doesn't have HW_OS
    ifeq ($(UNAME), CYGWIN_NT-4.0)
      HW_OS := pc_cygwin
      # On cygwin make is gmake (and gmake doesn't exist)
      MAKE  := make -f $(MAKEFILE)
    else
      ifeq ($(UNAME), CYGWIN_98-4.10)
	    HW_OS := pc_cygwin
	    MAKE := make -f $(MAKEFILE)
      else
        ifeq ($(UNAME), CYGWIN_NT-5.0)
	    HW_OS := pc_cygwin
	    MAKE := make -f $(MAKEFILE)
        else
	    HW_OS := $(shell hw_os)
        endif
      endif
    endif
  endif
endif

# Define defaults for the compilter, archiver, and ranlib.
CC := gcc
AR := ar ruv
RANLIB := ranlib

ifdef PBASE_ROOT
  HW_OS = hp_flow
  ifeq ($(PXFL_COMPILER), aCC)
    HW_OS = hp_flow_aCC
  endif
endif


ifeq ($(HW_OS),sgi_irix)
   ifndef SGI_ABI
      SGI_ABI := n32
   endif
   ifndef SGI_ARCH
      SGI_ARCH := mips3
   endif
   OBJECT_DIR_SUFFIX := .$(SGI_ABI).$(SGI_ARCH)
   CC = cc -$(SGI_ABI) -$(SGI_ARCH)
endif

AR := ar ruv
RANLIB := ranlib

ifeq ($(HW_OS), pc_cygwin)
endif

ifeq ($(HW_OS), hp700_hpux10)
  CC = cc -Ae
endif

ifeq ($(HW_OS), pc_linux)
endif

ifeq ($(HW_OS), pc_linux_ia64)
endif

ifeq ($(HW_OS), pc_linux64)
  CC = gcc -m64 -fPIC
endif

ifneq (,$(findstring macosx,$(HW_OS)))
  ifndef MAC_OS_MIN_VERSION
    MAC_OS_MIN_VERSION := 10.5
  endif

    # Select which compiler and MAC OS X SDK to use
    MAC_GCC := g++
    ifeq ($(MAC_OS_MIN_VERSION), 10.8)
      MAC_OS_SDK := MacOSX10.8.sdk
    else
    ifeq ($(MAC_OS_MIN_VERSION), 10.7)
      MAC_OS_SDK := MacOSX10.7.sdk
    else
   ifeq ($(MAC_OS_MIN_VERSION), 10.6)
      MAC_OS_SDK := MacOSX10.6.sdk
    else
      ifeq ($(MAC_OS_MIN_VERSION), 10.5)
        MAC_OS_SDK := MacOSX10.5.sdk
      else
        MAC_OS_SDK := MacOSX10.4u.sdk
        MAC_GCC := g++-4.0
      endif
    endif
  endif
 endif
endif

ifeq ($(HW_OS), powerpc_macosx)
  CC = $(MAC_GCC) -arch ppc -isysroot /Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
  AR = libtool -static -o
  RANLIB = :
endif

ifeq ($(HW_OS), universal_macosx)
  CC = $(MAC_GCC) -arch ppc -arch i386 -arch x86_64 -isysroot /Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
  AR = libtool -static -o
  RANLIB = :
endif

 ifeq ($(HW_OS), macosx_32_64)
        CC = $(MAC_GCC) -arch i386 -arch x86_64 -isysroot /Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
        RANLIB = :
        AR = libtool -static -o
	SYSLIBS = -framework CoreFoundation -framework IOKit -framework System
  endif
  
    ifeq ($(HW_OS), macosx_64)
  		 ifeq ($(MAC_OS_SDK), MacOSX10.6.sdk)
    		CC = $(MAC_GCC) -arch x86_64 -isysroot /Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
       else
     		CC = $(MAC_GCC) -arch x86_64 -isysroot /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
       endif
        RANLIB = :
        AR = libtool -static -o
		SYSLIBS = -framework CoreFoundation -framework IOKit -framework System
    endif


ifeq ($(HW_OS), pc_linux_arm)
  CC = arm-linux-gcc
  AR = arm-linux-ar ruv
  RANLIB = arm-linux-ranlib
endif

ifeq ($(HW_OS), pc_cygwin_arm)
  CC = arm-unknown-linux-gnu-gcc
  AR = arm-unknown-linux-gnu-ar ruv
  RANLIB = arm-unknown-linux-gnu-ranlib
endif

ifeq ($(HW_OS), sparc_solaris)
  CC = /opt/SUNWspro/bin/CC
endif

ifeq ($(HW_OS), sparc_solaris_64)
  CC = /opt/SUNWspro/bin/CC -xarch=v9a
endif

ifeq ($(HW_OS), hp_flow)
  CC = g++
endif

ifeq ($(HW_OS), hp_flow_aCC)
  CC = /opt/aCC/bin/aCC
endif


MAKEFILE = Makefile

QUAT_LIB = libquat.a

# flags
INCLUDE_FLAGS = -I.

ifeq ($(HW_OS), pc_cygwin)
  INCLUDE_FLAGS = -I.
endif

ifeq ($(HW_OS), hp_flow)
  INCLUDE_FLAGS =  -I. -I$(INCLUDE_INSTALL_DIR) -DFLOW
endif

ifeq ($(HW_OS), hp_flow_aCC)
  INCLUDE_FLAGS =  -I. -I$(INCLUDE_INSTALL_DIR) -DFLOW
endif

override CFLAGS := -g $(INCLUDE_FLAGS) $(CFLAGS)
override OPT_CFLAGS := -O $(INCLUDE_FLAGS) $(CFLAGS)

override LDFLAGS := -L. -L$(HW_OS) $(LDFLAGS)
LINT_FLAGS = $(INCLUDE_FLAGS)

#############################################################################
#
# for building library
#
#############################################################################

lib:	$(HW_OS)$(OBJECT_DIR_SUFFIX) libquat.a

$(HW_OS)$(OBJECT_DIR_SUFFIX):
	-mkdir -p $(HW_OS)$(OBJECT_DIR_SUFFIX)

#############################################################################
#
# example/test programs
#
#############################################################################

TEST_FILES = eul matrix_to_posquat qmat qmult qxform qmake timer qpmult

all :
	-rm $(TEST_FILES)
	$(MAKE) $(TEST_FILES)

#
# timer- time some operation
#
timer : timer.c
	$(CC) -o $@ $(CFLAGS) $(LDFLAGS) $@.c -lquat -lm

#
# matrix_to_posquat- matrix_to_posquat to quat
#
matrix_to_posquat : testapps/matrix_to_posquat.c
	$(CC) -o $(HW_OS)/$@ $(CFLAGS) $(LDFLAGS) testapps/$@.c -lquat -lm

#
# eul- eul to quat
#
eul : testapps/eul.c
	$(CC) -o $(HW_OS)/$@ $(CFLAGS) $(LDFLAGS) testapps/$@.c -lquat -lm

#
# qmult- multiply 2 quats
#
qmult : testapps/qmult.c
	$(CC) -o $(HW_OS)/$@ $(CFLAGS) $(LDFLAGS) testapps/$@.c -lquat -lm

#
# qpmult- multiply 2 pmatrices
#
qpmult : testapps/qpmult.c
	$(CC) -o $(HW_OS)/$@ $(CFLAGS) $(LDFLAGS) testapps/$@.c -lquat -lm

#
# qxform- xform a vec
#
qxform : testapps/qxform.c
	$(CC) -o $(HW_OS)/$@ $(CFLAGS) $(LDFLAGS) testapps/$@.c -lquat -lm

#
# qmat- matrix to quaternion
#
qmat : qmat.c
	$(CC) -o $(HW_OS)/$@ $(CFLAGS) $(LDFLAGS) testapps/$@.c -lquat -lm

#
# qmake- tests q_make
#
qmake : qmake.c
	$(CC) -o $(HW_OS)/$@ $(CFLAGS) $(LDFLAGS) $@.c -lquat -lm

oglconv : oglconv.c
	$(CC) -o $(HW_OS)/$@ $(CFLAGS) $(LDFLAGS) $@.c -lquat -lm

oglmult : oglmult.c
	$(CC) -o $(HW_OS)/$@ $(CFLAGS) $(LDFLAGS) $@.c -lquat -lm

#############################################################################
#
# rules and definitions for making quaternion library
#
#############################################################################

QUAT_INCLUDES = quat.h
QUAT_C_FILES = quat.c matrix.c vector.c xyzquat.c
QUAT_OBJ_FILES = $(QUAT_C_FILES:.c=.o)

$(QUAT_LIB) :  $(QUAT_OBJ_FILES) $(MAKEFILE)
	@echo "Building $@..."
	$(AR) $(QUAT_LIB) $(QUAT_OBJ_FILES)
	-$(RANLIB) $(QUAT_LIB)
	mv $(QUAT_LIB) *.o $(HW_OS)$(OBJECT_DIR_SUFFIX)

$(QUAT_OBJ_FILES) : $(QUAT_INCLUDES)

#############################################################################
#
# miscellaneous rules
#
#############################################################################

lint :
	lint $(LINT_FLAGS) $(COORD_FILES)

install: lib
	#-mkdir $(BIN_DIR)
	#( cd $(BIN_DIR) ; rm -f $(INSTALL_APPS) )
	#( cd $(OBJ_DIR) ; cp $(INSTALL_APPS) $(BIN_DIR) )
	#( cd $(BIN_DIR) ; strip $(INSTALL_APPS) )
	-mkdir -p $(LIB_DIR)
	( cd $(HW_OS)$(OBJECT_DIR_SUFFIX) ; cp $(QUAT_LIB) $(LIB_DIR) )
	-mkdir -p $(INCLUDE_DIR)
	cp quat.h $(INCLUDE_DIR)

allclean :
	-/bin/rm -f *.o *.a *~ *.j foo a.out $(TEST_FILES)
	-/bin/rm -fr $(HW_OS)$(OBJECT_DIR_SUFFIX)/*.o $(HW_OS)$(OBJECT_DIR_SUFFIX)/*.a

clean :
	-/bin/rm -f *.o *.a *~ *.j foo a.out $(TEST_FILES)
	-/bin/rm -fr $(HW_OS)$(OBJECT_DIR_SUFFIX)/*.o $(HW_OS)$(OBJECT_DIR_SUFFIX)/*.a


install: lib
	-mkdir -p $(LIB_INSTALL_DIR)
	( cd $(LIB_INSTALL_DIR) ; rm -f libquat.a )
	( cd $(HW_OS)$(OBJECT_DIR_SUFFIX) ; cp lib*.a $(LIB_INSTALL_DIR) )
	-mkdir -p $(INCLUDE_INSTALL_DIR)
	cp quat.h $(INCLUDE_INSTALL_DIR)

=== server_src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

#-----------------------------------------------------------------------------
# XXX Things to make better.
#
# Move applications into subprojects in visual studio
# XXX tracker_to_poser
# Fix the ones that are commented out so that they compile and run?

if(NOT VRPN_SERVER_LIBRARY)
	message(FATAL_ERROR
		"Cannot compile servers without the full (server) library.  Enable it and try again.")
endif()

set(VRPN_GPSNMEA_LIBRARY gpsnmea)

if(NOT WIN32)
	set(VRPN_ATMEL_LIBRARY vrpn_atmel)
endif()

if(WIN32)
	ADD_DEFINITIONS( -D_CRT_SECURE_NO_WARNINGS )
endif()

#-----------------------------------------------------------------------------
# Phantom library (if configured)
find_package(OpenGL)
if(VRPN_USE_PHANTOM_SERVER AND OPENGL_FOUND)
	set(PHANTOM_SOURCES
		ghostEffects/InstantBuzzEffect.cpp
		buzzForceField.C
		constraint.C
		forcefield.C
		plane.C
		texture_plane.C
		trimesh.C
		vrpn_Phantom.C)

	set(PHANTOM_HEADERS
		ghostEffects/InstantBuzzEffect.h
		buzzForceField.h
		constraint.h
		forcefield.h
		ghost.h
		plane.h
		texture_plane.h
		trimesh.h
		vrpn_Phantom.h)
	include_directories(${VRPN_SOURCE_DIR}/server_src/ghostEffects)
	if(VRPN_USE_GHOST AND GHOST_STL_INCLUDE_DIR)
		include_directories(${GHOST_STL_INCLUDE_DIR})
	endif()
	add_library(vrpn_phantom ${PHANTOM_SOURCES} ${PHANTOM_HEADERS})
	target_link_libraries(vrpn_phantom vrpnserver ${OPENGL_LIBRARIES})

	set_property(TARGET
		vrpn_phantom
		PROPERTY
		PUBLIC_HEADER
		${PHANTOM_HEADERS})
	set_target_properties(vrpn_phantom PROPERTIES FOLDER Library)

	if(VRPN_INSTALL)
		install(TARGETS
			vrpn_phantom
			ARCHIVE
			DESTINATION
			lib
			COMPONENT
			serversdk
			PUBLIC_HEADER
			DESTINATION
			include
			COMPONENT
			serversdk)
	endif()
	set(VRPNPHANTOMLIB vrpn_phantom)
endif()

#------------------------------------------------------------------
# DirectShow video server - only for pre-VS10 due to header removal
if(VRPN_BUILD_DIRECTSHOW_VIDEO_SERVER AND DIRECTSHOW_FOUND)
	add_subdirectory(directshow_video_server)
endif()

add_subdirectory(timecode_generator_server)

#-----------------------------------------------------------------------------
# Include directories needed
include_directories(${VRPN_SOURCE_DIR}/server_src
	${VRPN_SOURCE_DIR}/server_src/timecode_generator_server)

#-----------------------------------------------------------------------------
# Applications that need more than one file to run.
add_executable(vrpn_server
	vrpn.cfg
	vrpn.C)
target_link_libraries(vrpn_server
	${VRPN_SERVER_LIBRARY}
	vrpn_timecode_generator
	${VRPN_ATMEL_LIBRARY}
	${VRPN_GPSNMEA_LIBRARY}
	${VRPNPHANTOMLIB})
set_target_properties(vrpn_server PROPERTIES SOLUTION_FOLDER servers)
set_property(TARGET
	vrpn_server
	PROPERTY
	PROJECT_LABEL
	"vrpn_server")
set_target_properties(vrpn_server PROPERTIES FOLDER "Main Server")
set_property(TARGET
	vrpn_server
	PROPERTY
	LINK_FLAGS
	${SERVER_LINK_FLAGS})

if(VRPN_INSTALL)
	install(TARGETS vrpn_server
		RUNTIME DESTINATION bin
		COMPONENT mainserver)
endif()

if(VRPN_USE_NATIONAL_INSTRUMENTS)
	add_executable(daq_server
		daq_server.C
		NIUtil.cpp
		NIUtil.h)
	target_link_libraries(daq_server ${VRPN_SERVER_LIBRARY})
	set_target_properties(daq_server PROPERTIES FOLDER Servers)
	if(VRPN_INSTALL)
		install(TARGETS daq_server RUNTIME DESTINATION bin COMPONENT servers)
	endif()
endif()

#-----------------------------------------------------------------------------
# Install the vrpn.cfg file needed by the server.
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/vrpn.cfg"
	"${CMAKE_CURRENT_BINARY_DIR}/vrpn.cfg"
	@ONLY)

if(NOT SYSCONF_INSTALL_DIR)
	set(SYSCONF_INSTALL_DIR etc)
endif(NOT SYSCONF_INSTALL_DIR)

if(VRPN_INSTALL)
	if(WIN32)
		install(FILES "${CMAKE_CURRENT_BINARY_DIR}/vrpn.cfg"
			DESTINATION bin
			COMPONENT mainserver)
	else()
		install(FILES "${CMAKE_CURRENT_BINARY_DIR}/vrpn.cfg"
			DESTINATION ${SYSCONF_INSTALL_DIR}
			COMPONENT mainserver)
	endif()

	install(FILES "${CMAKE_CURRENT_BINARY_DIR}/vrpn.cfg"
		DESTINATION share/vrpn-${BRIEF_VERSION}
		RENAME vrpn.cfg.sample
		COMPONENT mainserver)
endif()

#-----------------------------------------------------------------------------
# Declaration of the simple test applications that don't have extra files

# XXX Are these files compiled somewhere?
#
#make_vrpn_libs_build.cpp

set(SRV_TEST_SOURCES
	client_and_server.C
	forward.C
	last_of_sequence.C
	sample_analog.C
	sample_server.C
	testSharedObjectServer.C
	test_analogfly.C
	test_auxiliary_logger.C
	test_freespace.C
	test_logging.C
	test_loopback.C
	test_mutexServer.C
	test_peerMutex.C
	test_radamec_spi.C
	test_rumble.C
	test_vrpn.C
	testimager_server.cpp
	textServer.C
)
if(VRPN_USE_HID)
	list(APPEND SRV_TEST_SOURCES vrpn_HID_device_watcher.cpp)
endif()

if(WIN32 AND VRPN_USE_DIRECTINPUT)
	list(APPEND SRV_TEST_SOURCES directXFF.C)
endif()

if(WIN32)
	list(APPEND SRV_TEST_SOURCES nidaqClient.cpp) # actually a client test
endif()

if(WIN32 AND VRPN_USE_NIDAQ)
#	list(APPEND SRV_TEST_SOURCES nidaqServer.cpp) # missing getOptClean
endif()

set(SRV_SERVER_SOURCES)

###
# Tests
###
if(BUILD_TESTING)
	foreach(SOURCE ${SRV_TEST_SOURCES})
		get_filename_component(APP ${SOURCE} NAME_WE)
		add_executable(${APP} ${SOURCE})
		target_link_libraries(${APP} ${VRPN_SERVER_LIBRARY})
		set_target_properties(${APP} PROPERTIES FOLDER Tests)

		if(VRPN_INSTALL)
			install(TARGETS ${APP}
				RUNTIME DESTINATION bin COMPONENT tests)
		endif()
	endforeach()
	add_test(test_vrpn test_vrpn)
	add_test(test_loopback test_loopback)
	add_test(test_analogfly test_analogfly)
	add_test(test_logging test_logging)
endif()

###
# Servers
###
foreach(SOURCE ${SRV_SERVER_SOURCES})
	get_filename_component(APP ${SOURCE} NAME_WE)
	add_executable(${APP} ${SOURCE})
	target_link_libraries(${APP} ${VRPN_SERVER_LIBRARY})
	set_target_properties(${APP} PROPERTIES FOLDER Servers)

	if(VRPN_INSTALL)
		install(TARGETS ${APP} RUNTIME DESTINATION bin COMPONENT servers)
	endif()
endforeach()

=== server_src/Makefile ===
# this is a gmake file

##########################
# common definitions. For non-UNC sites, uncomment one of the lines
# that defines hw_os for the machine you are on in the section just
# below. Then, the code should compile in your environment.
#
#HW_OS := sgi_irix
#HW_OS := sparc_solaris
#HW_OS := sparc_solaris_64
#HW_OS := hp700_hpux10
#HW_OS := pc_linux
#HW_OS := pc_linux64
#HW_OS := pc_linux_ia64
# Try using this to cross-compile for ARM on a PC running Linux
#HW_OS := pc_linux_arm
# Try using this to cross-compile for ARM on a PC running Cygwin
#HW_OS := pc_cygwin_arm
#HW_OS := pc_cygwin
#HW_OS := pc_FreeBSD
#HW_OS := powerpc_aix
#HW_OS := powerpc_macosx
#HW_OS := universal_macosx
#HW_OS := macosx_32_64
#HW_OS := macosx_64
##########################

##########################
# Mac OS X-specific options. If HW_OS is powerpc_macosx or universal_macosx,
# uncomment one line below to choose the minimum targeted OS X version and
# corresponding SDK. If none of the lines below is commented out, 10.5 will
# be the minimum version.
##########################
#MAC_OS_MIN_VERSION := 10.4
#MAC_OS_MIN_VERSION := 10.5
#MAC_OS_MIN_VERSION := 10.6
#MAC_OS_MIN_VERSION := 10.7
#MAC_OS_MIN_VERSION := 10.8

##########################
# Directories for installation

INSTALL_DIR := /usr/local
BIN_DIR := $(INSTALL_DIR)/bin
INCLUDE_DIR := $(INSTALL_DIR)/include
LIB_DIR := $(INSTALL_DIR)/lib

ifndef	HW_OS
# hw_os does not exist on FreeBSD at UNC
UNAME := $(shell uname -s)
ifeq ($(UNAME), FreeBSD)
  HW_OS := pc_FreeBSD
else
  # pc_cygwin doesn't have HW_OS
  ifeq ($(UNAME), CYGWIN_NT-4.0)
    HW_OS := pc_cygwin
    # On cygwin make is gmake (and gmake doesn't exist)
    MAKE  := make -f $(MAKEFILE)
  else
    ifeq ($(UNAME), CYGWIN_98-4.10)
		HW_OS := pc_cygwin
		MAKE := make -f $(MAKEFILE)
	else
	  HW_OS := $(shell hw_os)
	endif
  endif
endif
endif

# check if its for pxfl
ifdef PBASE_ROOT
  HW_OS := hp_flow
  ifeq ($(PXFL_COMPILER), aCC)
    HW_OS = hp_flow_aCC
  endif
endif

  ifneq (,$(findstring macosx,$(HW_OS)))
    ifndef MAC_OS_MIN_VERSION
      MAC_OS_MIN_VERSION := 10.5
    endif

    # Select which compiler and MAC OS X SDK to use
    MAC_GCC := g++
    ifeq ($(MAC_OS_MIN_VERSION), 10.8)
      MAC_OS_SDK := MacOSX10.8.sdk
    else
    ifeq ($(MAC_OS_MIN_VERSION), 10.7)
      MAC_OS_SDK := MacOSX10.7.sdk
    else
   ifeq ($(MAC_OS_MIN_VERSION), 10.6)
      MAC_OS_SDK := MacOSX10.6.sdk
    else
      ifeq ($(MAC_OS_MIN_VERSION), 10.5)
        MAC_OS_SDK := MacOSX10.5.sdk
      else
        MAC_OS_SDK := MacOSX10.4u.sdk
        MAC_GCC := g++-4.0
      endif
    endif
  endif
 endif
endif

CC := g++
ifeq ($(HW_OS),pc_cygwin)
	SYSLIBS := -lcygwin -luser32 -lgdi32 -lcomdlg32 -lwsock32 -lSetupApi
endif
ifeq ($(HW_OS),sparc_solaris)
	CC := /opt/SUNWspro/bin/CC
	SYSLIBS := -lsocket -lnsl
endif
ifeq ($(HW_OS),sparc_solaris_64)
	CC := /opt/SUNWspro/bin/CC -xarch=v9a
	SYSLIBS := -lsocket -lnsl
endif
ifeq ($(HW_OS),powerpc_aix)
#	CC := /usr/ibmcxx/bin/xlC_r -g -qarch=pwr3 -w
	CC := /usr/ibmcxx/bin/xlC_r $(DEBUG_FLAGS) -qarch=pwr3 -w
endif

ifeq ($(HW_OS), powerpc_macosx)
	CC := $(MAC_GCC) -arch ppc -isysroot /Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
	RANLIB := ranlib
	AR := libtool -static -o
	SYSLIBS := -framework CoreFoundation -framework IOKit -framework System
endif

ifeq ($(HW_OS),universal_macosx)
        CC := $(MAC_GCC) -arch ppc -arch i386 -arch x86_64 -isysroot /Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
	RANLIB := :
	AR := libtool -static -o
	SYSLIBS := -framework CoreFoundation -framework IOKit -framework System
endif

   ifeq ($(HW_OS), macosx_32_64)
        CC := $(MAC_GCC) -arch i386 -arch x86_64 -isysroot /Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
        RANLIB := :
        AR := libtool -static -o
	SYSLIBS := -framework CoreFoundation -framework IOKit -framework System
  endif
  
    ifeq ($(HW_OS), macosx_64)
  		 ifeq ($(MAC_OS_SDK), MacOSX10.6.sdk)
    		CC := $(MAC_GCC) -arch x86_64 -isysroot /Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
       else
     		CC := $(MAC_GCC) -arch x86_64 -isysroot /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/$(MAC_OS_SDK) -mmacosx-version-min=$(MAC_OS_MIN_VERSION)
       endif
        RANLIB := :
        AR := libtool -static -o
		SYSLIBS := -framework CoreFoundation -framework IOKit -framework System
    endif

ifeq ($(HW_OS),pc_linux_ia64)
	CC := g++
	SYSLIBS := 
endif
ifeq ($(HW_OS),pc_linux64)
	CC := g++ -m64
	SYSLIBS := 
endif
ifeq ($(HW_OS), pc_linux_arm)
	CC := arm-linux-g++
	RANLIB := arm-linux-ranlib
	AR := arm-linux-ar ruv
endif
ifeq ($(HW_OS), pc_cygwin_arm)
	CC := arm-unknown-linux-gnu-g++
	RANLIB := arm-unknown-linux-gnu-ranlib
	AR := arm-unknown-linux-gnu-ar ruv
endif
ifeq ($(HW_OS),pc_linux)
	SYSLIBS := 
# For WiiMote
#	SYSLIBS := -lwiiuse
# For GPM mouse
#	SYSLIBS := -lgpm
# For Isense libraries
#	SYSLIBS := -ldl
# For Freespace Devices
#	SYSLIBS := -lfreespace
# For HID devices
	SYSLIBS := -lusb-1.0
endif
ifeq ($(HW_OS),pc_linux64)
	SYSLIBS := 
# For WiiMote
#	SYSLIBS := -lwiiuse
# For GPM mouse
#	SYSLIBS := -lgpm
# For Isense libraries
#	SYSLIBS := -ldl
# For Freespace Devices
#	SYSLIBS := -lfreespace
	SYSLIBS := -lusb-1.0
endif

ifeq ($(HW_OS),sgi_irix)
   ifndef SGI_ABI
      SGI_ABI := n32
   endif
   ifndef SGI_ARCH
      SGI_ARCH := mips3
   endif
   OBJECT_DIR_SUFFIX := .$(SGI_ABI).$(SGI_ARCH)
   CC := CC -$(SGI_ABI) -$(SGI_ARCH) -LANG:std
   GL := -lgl
endif

ifeq ($(HW_OS),hp700_hpux10)
	CC := CC +a1
endif
ifeq ($(HW_OS),sparc_sunos)
	CC := /usr/local/lib/CenterLine/bin/CC
endif

ifeq ($(HW_OS), hp_flow_aCC)
	CC := /opt/aCC/bin/aCC
endif

OBJ_DIR := $(HW_OS)$(OBJECT_DIR_SUFFIX)
LIB_DIR := ../$(OBJ_DIR)

# Jean SIMARD <jean.simard@limsi.fr>
# Definition of the 'TRUE' and 'FALSE' constant for Linux (by default, they are 
# defined in <windows.h>)
# XXX This would be better done in the .h/.C files with #ifndef
override CFLAGS := $(CFLAGS) -I./ -I../ -I../quat -I../../libfreespace/include $(DEBUG_FLAGS) $(CFLAGS) -DTRUE=true =DFALSE=false
override CXXFLAGS := $(CXXFLAGS) -I./ -I../ -I../quat -I../../libfreespace/include $(DEBUG_FLAGS) $(CXXFLAGS)
override LFLAGS := $(LFLAGS) -L$(LIB_DIR) -L../quat/$(HW_OS)$(OBJECT_DIR_SUFFIX) $(LDFLAGS)
VRPN_LIBS = -lvrpnserver -lvrpnatmel -lvrpngpsnmea -lpthread

# Uncomment the following section and point them at the
# currect diretories to compile with HDAPI under Cygwin.
# Well, to make it almost compile -- link fails to find things
# in the libraries that should be there.
#HDAPI_ROOT := "C:/Program Files/SensAble/3DTouch"

# Jean SIMARD <jean.simard@limsi.fr>
# This is only for the PHANToM server on Linux (not tested on other plateform)
# Put in comment if you don't want a PHANToM server
#override CFLAGS += -I$(HDAPI_ROOT)/include -I$(HDAPI_ROOT)/utilities/include
#override CXXFLAGS += -I$(HDAPI_ROOT)/include -I$(HDAPI_ROOT)/utilities/include
#override LFLAGS += -L$(HDAPI_ROOT)/lib
#SYSLIBS := $(SYSLIBS) -lHL -lHD -lHLU -lHDU

# This is for the PHANToM/GHOST server on SGI (not tested on other plateform)
# Put in comment if you don't want a PHANToM server.  GHOST expects SGI to
# be defined during compile, whereas sgi seems to be the standard definition.
#override CFLAGS += -I/usr/local/SensAble/GHOST/v31/include -DSGI
#override CXXFLAGS += -I/usr/local/SensAble/GHOST/v31/include -DSGI
#override LFLAGS += -L/usr/local/SensAble/GHOST/v31/lib
#SYSLIBS := $(SYSLIBS) -lghost31_32

ifdef INTERSENSE
  ifeq ($(HW_OS),powerpc_macosx)
#     CFLAGS = -g -I../ -I../../quat -I../../isense -DMACOSX
     override CFLAGS += -I../../isense -DMACOSX
     override CXXFLAGS += -I../../isense -DMACOSX
     override LFLAGS += ../../isense/MacOSX/dlcompat.o
  endif
  ifeq ($(HW_OS),universal_macosx)
#     CFLAGS = -g -I../ -I../../quat -I../../isense -DMACOSX
     override CFLAGS += -I../../isense -DMACOSX
     override CXXFLAGS += -I../../isense -DMACOSX
     override LFLAGS += ../../isense/MacOSX/dlcompat.o
	
  endif
endif

#uncomment the following lines to include the PHASESPACE library
#PHASESPACE := -L../../phasespace -lowlsock
#CXXFLAGS += -I../../phasespace
#CFLAGS += -I../../phasespace

ifdef PHASESPACE
#the rpath option may not work on all platforms, remove it if necessary.
EXTRAOPTS := -Wl,-rpath .
override LFLAGS += $(PHASESPACE) $(EXTRAOPTS)
endif

.SUFFIXES: .cpp

.C.o:
	$(CC) $(CXXFLAGS) -c $*.C

.c.o:
	$(CC) $(CFLAGS) -c $*.c

.cpp.o:
	$(CC) $(CXXFLAGS) -c $*.cpp

$(OBJ_DIR)/%.o:	%.c
	@[ -d $(OBJ_DIR) ] || mkdir -p $(OBJ_DIR)
	$(CC) $(CFLAGS) -o $@ -c $<

$(OBJ_DIR)/%.o:	%.C
	@[ -d $(OBJ_DIR) ] || mkdir -p $(OBJ_DIR)
	$(CC) $(CXXFLAGS) -o $@ -c $<

$(OBJ_DIR)/%.o:	%.cpp
	@[ -d $(OBJ_DIR) ] || mkdir -p $(OBJ_DIR)
	$(CC) $(CXXFLAGS) -o $@ -c $<

INSTALL_APPS := vrpn_server test_vrpn
APPS := $(INSTALL_APPS) client_and_server test_mutexServer test_peerMutex \
test_radamec_spi test_analogfly testimager_server test_auxiliary_logger \
test_logging testSharedObjectServer
# test_freespace
# 

all: $(APPS)

.PHONY:	vrpn_server
vrpn_server:	$(OBJ_DIR)/vrpn_server

.PHONY:	test_radamec_spi
test_radamec_spi:	$(OBJ_DIR)/test_radamec_spi

.PHONY:	testimager_server
testimager_server:	$(OBJ_DIR)/testimager_server

.PHONY:	test_logging
test_logging:	$(OBJ_DIR)/test_logging

.PHONY:	test_freespace
test_freespace:	$(OBJ_DIR)/test_freespace

.PHONY:	test_auxiliary_logger
test_auxiliary_logger:	$(OBJ_DIR)/test_auxiliary_logger

.PHONY:	test_analogfly
test_analogfly:	$(OBJ_DIR)/test_analogfly

.PHONY:	test_vrpn
test_vrpn:	$(OBJ_DIR)/test_vrpn

.PHONY:	client_and_server
client_and_server:	$(OBJ_DIR)/client_and_server

.PHONY:	sample_server
sample_server:	$(OBJ_DIR)/sample_server

.PHONY:	test_mutexServer
test_mutexServer:	$(OBJ_DIR)/test_mutexServer

.PHONY:	test_peerMutex
test_peerMutex:	$(OBJ_DIR)/test_peerMutex

.PHONY:	sample_analog
sample_analog:	$(OBJ_DIR)/sample_analog

.PHONY:	forward
forward:	$(OBJ_DIR)/forward

.PHONY:	textServer
textServer:	$(OBJ_DIR)/textServer

.PHONY:	last_of_sequence
last_of_sequence:	$(OBJ_DIR)/last_of_sequence

.PHONY:	testSharedObjectServer
testSharedObjectServer:	$(OBJ_DIR)/testSharedObjectServer

$(OBJ_DIR)/InstantBuzzEffect.o: ghostEffects/InstantBuzzEffect.cpp
	$(CC) $(CXXFLAGS) -o $@ -c $<

$(OBJ_DIR)/vrpn_server: $(OBJ_DIR)/vrpn.o $(LIB_DIR)/libvrpnserver.a \
		$(OBJ_DIR)/buzzForceField.o $(OBJ_DIR)/constraint.o \
		$(OBJ_DIR)/forcefield.o $(OBJ_DIR)/plane.o \
		$(OBJ_DIR)/texture_plane.o $(OBJ_DIR)/trimesh.o \
		$(OBJ_DIR)/vrpn_Phantom.o \
		$(OBJ_DIR)/InstantBuzzEffect.o \
		$(OBJ_DIR)/vrpn_Generic_server_object.o 
	$(CC) $(LFLAGS) -o $(OBJ_DIR)/vrpn_server $(OBJ_DIR)/vrpn.o \
		$(OBJ_DIR)/buzzForceField.o $(OBJ_DIR)/constraint.o \
		$(OBJ_DIR)/forcefield.o $(OBJ_DIR)/plane.o \
		$(OBJ_DIR)/texture_plane.o $(OBJ_DIR)/trimesh.o \
		$(OBJ_DIR)/vrpn_Phantom.o \
		$(OBJ_DIR)/InstantBuzzEffect.o \
		$(OBJ_DIR)/vrpn_Generic_server_object.o \
		$(VRPN_LIBS) $(GL) -lquat $(SYSLIBS) -lm

$(OBJ_DIR)/test_vrpn: $(OBJ_DIR)/test_vrpn.o  \
			 $(LIB_DIR)/libvrpnserver.a
	$(CC) $(LFLAGS) -o $(OBJ_DIR)/test_vrpn \
		$(OBJ_DIR)/test_vrpn.o \
		$(VRPN_LIBS) $(GL) -lquat $(SYSLIBS) -lm

$(OBJ_DIR)/test_radamec_spi: $(OBJ_DIR)/test_radamec_spi.o  \
			 $(LIB_DIR)/libvrpnserver.a
	$(CC) $(LFLAGS) -o $(OBJ_DIR)/test_radamec_spi \
		$(OBJ_DIR)/test_radamec_spi.o \
		$(VRPN_LIBS) $(GL) -lquat $(SYSLIBS) -lm

$(OBJ_DIR)/testimager_server: $(OBJ_DIR)/testimager_server.o  \
			 $(LIB_DIR)/libvrpnserver.a
	$(CC) $(LFLAGS) -o $(OBJ_DIR)/testimager_server \
		$(OBJ_DIR)/testimager_server.o \
		$(VRPN_LIBS) $(GL) -lquat $(SYSLIBS) -lm

$(OBJ_DIR)/test_auxiliary_logger: $(OBJ_DIR)/test_auxiliary_logger.o  \
			 $(LIB_DIR)/libvrpnserver.a
	$(CC) $(LFLAGS) -o $(OBJ_DIR)/test_auxiliary_logger \
		$(OBJ_DIR)/test_auxiliary_logger.o \
		$(VRPN_LIBS) $(GL) -lquat $(SYSLIBS) -lm

$(OBJ_DIR)/test_logging: $(OBJ_DIR)/test_logging.o  \

=== submodules/CMakeLists.txt ===

# This file includes a cmake file per submodule, and then
# sends the variables it sets to the parent scope, which is the parent
# (main) directory.

###
# HIDAPI
###

include("hidapi.cmake")
if(VRPN_USE_LOCAL_HIDAPI)
	set(HIDAPI_FOUND ${HIDAPI_FOUND} PARENT_SCOPE)
	set(HIDAPI_INCLUDE_DIRS ${HIDAPI_INCLUDE_DIRS} PARENT_SCOPE)
	set(HIDAPI_LIBRARIES ${HIDAPI_LIBRARIES} PARENT_SCOPE)
	set(HIDAPI_SOURCES ${HIDAPI_SOURCES} PARENT_SCOPE)
endif()

###
# JSONCPP
###
include("jsoncpp.cmake")
if(VRPN_USE_LOCAL_JSONCPP)
	set(JSONCPP_FOUND ${JSONCPP_FOUND} PARENT_SCOPE)
	set(JSONCPP_INCLUDE_DIRS ${JSONCPP_INCLUDE_DIRS} PARENT_SCOPE)
	set(JSONCPP_LIBRARIES ${JSONCPP_LIBRARIES} PARENT_SCOPE)
	set(JSONCPP_SOURCES ${JSONCPP_SOURCES} PARENT_SCOPE)
endif()

=== PKGBUILD ===
# Maintainer: Philippe Renon <philippe.renon@yahoo.fr>

_realname=vrpn
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=7.35
_pkgver=0${pkgver}
pkgrel=2
pkgdesc="The Virtual-Reality Peripheral Network (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://github.com/vrpn/vrpn/wiki"
license=('spdx:BSL-1.0')
depends=("${MINGW_PACKAGE_PREFIX}-hidapi"
         "${MINGW_PACKAGE_PREFIX}-jsoncpp"
         "${MINGW_PACKAGE_PREFIX}-libusb"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-freeglut"
         "${MINGW_PACKAGE_PREFIX}-swig")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/${_realname}/${_realname}/archive/v${_pkgver}/${_realname}-${pkgver}.tar.gz"
        "0002-fix-shared-build.patch"
        "0003-fix-includes.patch")
sha256sums=('83139846247e6a0530b974e03744bb358d11f88109f231a3031815924374bb9d'
            '14855180b0f6612b548ccf56a4b66de3fb1ef69b4b6418ab76e39fd643e9e609'
            'a2c08e4d18213aaacfa32894c284015c42dd72af609611c8c4cf36048ed26447')

prepare() {
  cd "${srcdir}/${_realname}-${_pkgver}"

  patch -p1 -i ${srcdir}/0002-fix-shared-build.patch
  patch -p1 -i ${srcdir}/0003-fix-includes.patch
}

build() {
  mkdir -p ${srcdir}/build-${MSYSTEM} && cd ${srcdir}/build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake -Wno-dev \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DDIRECTX_ROOT_DIR=${MINGW_PREFIX} \
    -DWINHID_ROOT_DIR=${MINGW_PREFIX} \
    -DVRPN_USE_SHARED_LIBRARY=ON \
    -DVRPN_USE_WINSOCK2=ON \
    -DVRPN_BUILD_JAVA=OFF \
    -DVRPN_USE_MPI=OFF \
    -DPYTHON_LIBRARY=${MINGW_PREFIX}/bin/libpython${_pyver}.dll \
    -DPYTHON_INCLUDE_DIR=${MINGW_PREFIX}/include/python${_pyver} \
    "${extra_config[@]}" \
    ../${_realname}-${_pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .

  install -Dm644 ${srcdir}/${_realname}-${_pkgver}/README.Legal "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}/LICENSE
}
